import numpy as np
from scipy import integrate

def multipolceff(num_arg, eval_rad, dist_elec, m_order,filename,num_ele, multi_num, printterm,savename):
    ''' num_arg is number of evaluation points for calculating multipolcoeff
        eval_rad is radius
        order_multi = m_order
    '''
    phiCount = num_arg
    phi = np.mgrid[0:2*np.pi:phiCount*1j]   
    R =  eval_rad
    r0 = dist_elec  # distance to electrodes
    order_multi = m_order
    nu = num_ele
    print 'load potential at evaluation points' 
    data = np.loadtxt(filename)
    evalpotkoeff = data[:,2]
    fourier_cos = []
    fourier_sin = []
    multipol_coeff = []
    
    for k in range(order_multi):
        for i in xrange(phiCount):
            fourier_cos.append((evalpotkoeff[i]*np.cos(k*phi[i]) ))
            fourier_sin.append((evalpotkoeff[i]*np.sin(k*phi[i]) ))


    cos_term = np.split(np.array(fourier_cos), order_multi)
    sin_term = np.split(np.array(fourier_sin), order_multi)
    h = (2*np.pi)/(phiCount-1)
    for i in xrange(order_multi):
        multipol_coeff.append((i, (integrate.trapz(cos_term[i],dx=h)/np.pi*(r0/R)**i), (integrate.trapz(sin_term[i],dx=h)/np.pi*(r0/R)**i)))
	if printterm == True:
            print i, (integrate.trapz(cos_term[i],dx=h)/np.pi*(r0/R)**i),',', (integrate.trapz(sin_term[i],dx=h)/np.pi*(r0/R)**i)
        else:
	    pass
    r0_eff = r0/abs((integrate.trapz(cos_term[multi_num],dx=h)/np.pi*(r0/R)**multi_num))**.5
    #print integrate.trapz(cos_term[multi_num],dx=h)
    np.savetxt('multipol_coeff_'+savename,multipol_coeff,header=str(r0_eff))
    #print (integrate.trapz(cos_term[multi_num],dx=h)/np.pi*(r0/R)**multi_num),',', (integrate.trapz(sin_term[multi_num],dx=h)/np.pi*(r0/R)**multi_num)
    return (integrate.trapz(cos_term[multi_num],dx=h)/np.pi*(r0/R)**multi_num)
