from cython_gsl cimport *
cimport numpy as np

def ccw(double Ax,double Ay,double Bx,double By,double Cx,double Cy):
    return (Cy-Ay)*(Bx-Ax) > (By-Ay)*(Cx-Ax)

#def intersection(double x,double y):
def intersection(np.ndarray[double, ndim=2] S1,np.ndarray[double, ndim=2] S2):
    Ax = S1[0][0]
    Ay = S1[0][1]
    Bx = S1[1][0]
    By = S1[1][1] 
    Cx = S2[0][0]
    Cy = S2[0][1]
    Dx = S2[1][0]
    Dy = S2[1][1]
    return ccw(Ax,Ay,Cx,Cy,Dx,Dy) != ccw(Bx,By,Cx,Cy,Dx,Dy) and ccw(Ax,Ay,Bx,By,Cx,Cy) != ccw(Ax,Ay,Bx,By,Dx,Dy)
