import numpy as np
from scipy import special
from scipy.integrate import simps,trapz,romb
# this works fine

############################################
# load potential at evaluation points

filename = 'potential_rad=12_num_of_elem_972'
data = np.loadtxt(filename+'.txt')
data1 = np.loadtxt('gauss_n_w_31.txt')
ws = (data1[:,1]) # gauss weights
rad = 3.0
r0 = 5.0

# define used function (normalized associated legendre, multipole coefficient)
def asso_leg(m,n,winkel):
    if m ==0:
        return (-1)**m*special.lpmn(-m, n, winkel)[0][m][n]*(2*n+1)/2.
    else:
        return (-1)**m*special.lpmn(-m, n, winkel)[0][m][n]*(2*n+1)


############################################



#####################################################################

number_theta = len(data1[:,0])
theta = data1[:,0]  

# calculate rf multipole coefficient
def coeff(k,order):
    list_rf = []
    if k == 0:
        field = data[:,1]
        def a_m_n_rf(m,n):
            legendre_liste = []
            for k in range(number_theta):
                legendre_liste.append(( asso_leg(0,n,theta[k]) ))
            legendre_array = np.array(legendre_liste)
            return np.sum(field*legendre_array*ws)
        for n in range(order):
            print n,a_m_n_rf(0,n)*(r0/rad)**n
            list_rf.append((n,a_m_n_rf(0,n)*(r0/rad)**n))
        np.savetxt('coeff_'+filename+'txt', list_rf)
    else:
        field = data[:,2]
        section_rf = np.split(field,number_theta)
        phi_split = np.split(data[:,1],number_theta)
        number_phi = 20*number_theta
        def a_m_n_rf(m,n):
            fourier_liste = []
            legendre_liste = []
            for k in range(number_theta):
                fourier_liste.append(( trapz(np.cos(-m*phi_split[0])*section_rf[k],dx = 1/(number_phi-1.) ) ))
                legendre_liste.append(( asso_leg(m,n,theta[k]) ))
            fourier_array = np.array(fourier_liste)
            legendre_array = np.array(legendre_liste)
            return np.sum(fourier_array*legendre_array*ws)
        list_rf = []
        for m in range(order):
            for k in range(7):
                n = m+k
                if abs(a_m_n_rf(m,n)) >=5e-08:
                    print m,n,a_m_n_rf(m,n)*(r0/rad)**n
                    #list_rf.append((m,n,a_m_n_rf(m,n)**(r0/rad)**n))
                else:
                    pass


# calculate multipole coeffitients up to order 12 for axis symmetric case
coeff(0,12)
